<template>
<div class="facet-container">
  <div class="flex justify-between">
    <h3 class="mb-1">{{ title }}</h3>
    <Button v-if="selected.length > 0" class="p-0" text size="mini" @click="reset">zurücksetzen</Button>
  </div>
  <div class="facet-content flex flex-col w-full">
    <template v-if="loading">
      <Skeleton class="mb-4" height="2.5rem" />
      <div class="flex mb-1.5" v-for="i in [1,2,3]">
        <Skeleton height="1.4rem" width="86%"/>
        <Skeleton class="ml-auto" height="1.4rem" width="2.3rem"/>
      </div>
      <Skeleton class="mt-3" height="2.2rem" width="10rem" />

    </template>
    <template v-else>
      <multiselect
        ref="facetSearch"
        v-if="facet && showSearch"
        class="facet-select"
        :disabled="disableFacets"
        :class="{'is-collapsed': isCollapsed}"
        :modelValue="selected"
        @update:modelValue="onSelected"
        :id="'facet-input-' + field"
        placeholder="Bitte eingeben..."
        :options="filteredFields"
        label="label"
        track-by="term"
        :multiple="true"
        :show-labels="false"
        selected-label=""
        deselect-label=""
        tag-placeholder=""
        :close-on-select="false"
        @search-change="onChange($refs.facetSearch.filteredOptions.length)"
        @remove="onRemove"
        @select="onSelect">
        <template #option="props">
          <CheckboxOption
            :binary="true"
            :value="props.option.selected"
            :inputId="props.option.label"
            :label="props.option.label"
            :isSelected="props.option.selected"
            :count="props.option.count"
            >
            <template #leftIcon>
              <slot name="orderIcon" :icon="props.option.label"></slot>
            </template>
          </CheckboxOption>
        </template>
        <template #noResult>Keine Treffer</template>
      </multiselect>
      <div v-if="!showSearch" v-for="(field, i) in filteredFields">
        <CheckboxOption
          class="mb-1" 
          v-model="selectedCheckboxes" 
          @change="onCheckboxChange" 
          :inputId="field.term + i"
          :value="field.term"
          :label="field.label"
          :isSelected="selectedCheckboxes.includes(field.label)"
          :count="field.count"
          >
        </CheckboxOption>
      </div>
      <Button
        v-if="filteredFieldsAmount > 7"
        text
        size="small"
        :icon="isCollapsed ? 'pi pi-plus' : 'pi pi-minus'"
        :label="(isCollapsed) ? (filteredFieldsAmount - 7) + ' weitere anzeigen' : 'zuklappen'"
        class="self-start py-2"
        @click="onCollapseToggle">
      </Button>
    </template>

  </div>
</div>
</template>

<script>
import Multiselect from 'vue-multiselect';
import CheckboxOption from '@/components/CheckboxOption.vue';
import { mapGetters } from 'vuex';

export default {
  name: 'Facet',
  components: { Multiselect, CheckboxOption },
  data: () => ({
    selected: [],
    selectedCheckboxes: [],
    filteredFields: [],
    filteredFieldsAmount: 0,
    isCollapsed: true,
  }),
  props: {
    title: {
      default: '',
    },
    field: {
      default: '',
    },
    facet: {
      default: null,
    },
    showSearch: {
      default: true,
    },
  },
  computed: {
    ...mapGetters([
      'getLoadingFacet',
    ]),
    loading () {
      return this.getLoadingFacet(this.field);
    },
    disableFacets () {
      return this.$store.state.disableFacets;
    },
  },
  methods: {
    onRemove (option) {
      const index = this.filteredFields.findIndex(field => field.term === option.term);
      if (index > -1) {
        this.filteredFields[index].selected = false;
      }
    },
    onSelect (option) {
      const index = this.filteredFields.findIndex(field => field.term === option.term);
      this.filteredFields[index].selected = true;
    },
    onSelected (selected) {
      this.selected = selected;
      this.$emit('facetChange', this.selected.map(selectedOption => selectedOption.term));
    },
    onChange (filteredFieldsAmount) {
      this.filteredFieldsAmount = filteredFieldsAmount;
      this.isCollapsed = this.filteredFieldsAmount > 7;
    },
    onCollapseToggle () {
      this.isCollapsed = !this.isCollapsed;
    },
    onCheckboxChange (event) {
      this.selected = this.selectedCheckboxes.map(s => ({ label: s, term: s }));
      this.$emit('facetChange', this.selected.map(selectedOption => selectedOption.term));
    },
    reset () {
      this.selected = [];
      this.filteredFields.forEach(field => field.selected = false);
      this.selectedCheckboxes = [];
      this.$emit('facetChange', []);
    },
  },
  watch: {
    facet: {
      immediate: true,
      handler: function (facet) {
        if (facet) {
          // If facet comes with active items we need to set them programmatically
          this.selected = facet.active ? facet.active.map(term => ({ label: term, term })) : [];
          this.selectedCheckboxes = this.selected.map(item => item.term);
          this.filteredFields = facet.values.map(field => ({
            ...field,
            selected: this.selected.findIndex(option => option.term === field.term) > -1,
          }));
          this.filteredFieldsAmount = this.filteredFields.length;

          if (this.showSearch) {
            this.$nextTick(() => {
              this.$refs.facetSearch.isOpen = true;
              // TODO: we replace the decativate method completely to not close the options list on blur, very ugly
              this.$refs.facetSearch.deactivate = () => {};
            });
          }
        }
      },
    },
  },
};
</script>

<style lang="scss">
.facet-content {
  min-height: 100px;
}

.facet-select {
  &.is-collapsed {
    &.multiselect .multiselect__content-wrapper {
      max-height: 208px !important;
    }
  }
  &.multiselect {
    &.multiselect--active {
       z-index: 40;
      .multiselect__tags {
        @apply rounded-md border-2 border-gray-300 !important;
      }
    }
    .multiselect__content-wrapper {
      max-height: none !important;
      @apply relative overflow-hidden shadow-none border-none pt-2;
     }

    .multiselect__content {
      @apply w-full;
    }

    .multiselect__input {
      @apply bg-transparent;
      &::placeholder {
          @apply text-gray-500;
       }
     }

    .multiselect__select {
      display: none;
    }

    .multiselect__option {
      min-height: 0;
      padding-top: 6px;
      padding-bottom: 6px;
      height: 28px;
      @apply px-0 text-gray-700;
      &--highlight {
        @apply bg-transparent text-gray-700;
        &:after {
           @apply bg-transparent;
         }
      }

      &--selected {
         @apply bg-transparent text-primary-500;
        &.multiselect__option--highlight {
           @apply bg-transparent text-primary-500;
        }

        span {
          @apply text-primary-500;
        }
      }
    }
  }
  &.multiselect--disabled {
    @apply bg-gray-100;
  }
}

.multiselect__tag {
  @apply bg-gray-100 text-gray-700 leading-6 pl-2 pr-8;
}

.multiselect__tag-icon {
  @apply flex items-center justify-center right-[4px];
}

.multiselect__tag-icon:after {
  @apply text-gray-700 hover:text-gray-800 rounded-full border border-2 border-gray-700 h-[17px] w-[17px] flex items-center justify-center;
}
</style>
